﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=11.5
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	
#End Region

Sub Process_Globals

	Private nid As Int = 1
	Public seconds As Int
	Public activeState As Boolean		'Para que lo sepa la activity Main
	Public PhAwake As PhoneWakeState	'Librería Phone
	Public Take As Boolean				'La variable de comunicación sobre el momento de hacer la foto programada entre el servicio y la activity Main
End Sub


Sub Service_Create

	Service.AutomaticForegroundMode = Service.AUTOMATIC_FOREGROUND_NEVER 'Lo estamos manejando nosotros mismos
	PhAwake.PartialLock
	activeState = True
	Take = False
End Sub


Sub Service_Start (StartingIntent As Intent)
	
	Service.StartForeground(nid, CreateNotification("Taking photo..."))
	Log("Service_Start")
	
	StartServiceAt(Me, DateTime.Now + (seconds * 1000), True)		'ticks
'	StartServiceAtExact(Me, DateTime.Now + (seconds * 1000), True)	'Si targetSdkVersion="31" junto con la línea AddPermission(android.permission.SCHEDULE_EXACT_ALARM) en el Manifest Editor
	
	'Enciende la pantalla:
	PhAwake.KeepAlive(True)
	
'	If IsPaused(Main) Then StartActivity(Main)
	StartActivity(Main)		'Siempre para que funcione
	
	Take = True
	
	CallSub(Main, "InitializeCamera")		'Para que se prepare a hacer la foto si hemos girado el dispositivo
	
	PhAwake.ReleaseKeepAlive
	
	ToastMessageShow("Servicio PhotoTacker activo", True)
End Sub


Sub CreateNotification (Body As String) As Notification
	
	Dim notification As Notification
	notification.Initialize2(notification.IMPORTANCE_DEFAULT)
	notification.Icon = "icon"
	notification.SetInfo("Taking photo", Body, Main)
	Return notification
End Sub


Sub Service_Destroy

	activeState = False
	PhAwake.ReleasePartialLock
    Service.StopAutomaticForeground
	CancelScheduledService(Me)
End Sub
